﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace PenduleBalistique
{
 public partial class Page : UserControl
 {
  double m = 10,   // poids en grammes de la balle
        M = 100, // poids en grammes du pendule
        V = 400;  // vitesse de la balle en m/s
  bool bAnimEnCours;
  public Page()
  {
   InitializeComponent();
  }
  void animPenduleFin_Completed(object sender, EventArgs e)
  {
   bAnimEnCours = false;
  }

  void animPendule_Completed(object sender, EventArgs e)
  {
   da1AnimPenduleFin.Value = angle / 2;
   da2AnimPenduleFin.Value = -angle / 4;
   da3AnimPenduleFin.Value = angle / 8;
   da4AnimPenduleFin.Value = 0;
   animPenduleFin.Begin();

   // dessiner angle
   L2.X2 = 415 + 270 * Math.Sin(angleRad);
   L2.Y2 = 215 + 270 * Math.Cos(angleRad);
   afficheAngle.SetValue(Canvas.LeftProperty, (double)(425 + angle / 90 * 100));
   afficheAngle.Text = angle.ToString("##.#") + "°";

   E3.SetValue(Canvas.LeftProperty, 410 + 240 * Math.Sin(angleRad));
   E3.SetValue(Canvas.TopProperty, 210 + 240 * Math.Cos(angleRad));

   scaleAfficheHauteur.ScaleY = H * 240 / (100 * 100); // 1 mètre du fil en 240 pixels

   afficheInfo.Opacity = 1;
  }
  double angle, angleRad, H;
  void animBalle_Completed(object sender, EventArgs e)
  {
   // démarrer l'animation du pendule
   // calculer H
   H = 0.5 / 9.81 * (m / M * V) * (m / M * V);
   // supposons une longueur de fil d'un mètre (représenté ici en 240 pixels)
   angleRad = Math.Acos((240 - (H * 2.4)) / 240);
   angle = angleRad * 360 / 6.28;

   daAnimPendule.To = -angle;
   animBalleQuiTombe.Begin();
   animPendule.Begin();
  }

  void animBalleQuiTombe_Completed(object sender, EventArgs e)
  {
   balle.Opacity = 0;
   balle.SetValue(Canvas.LeftProperty, 160.0);
   balle.SetValue(Canvas.TopProperty, 450.0);
  }

  bool bCurseurVitesseBalleEnAction;
  double PosPrec;
  void vitesseBalleCurseur_MouseLeftButtonUp(object sender, MouseEventArgs e)
  {
   bCurseurVitesseBalleEnAction = false;
   vitesseBalleCurseur.ReleaseMouseCapture();
  }

  void vitesseBalleCurseur_MouseLeftButtonDown(object sender, MouseEventArgs e)
  {
   bCurseurVitesseBalleEnAction = true;
   PosPrec = e.GetPosition(vitesseBalle).X;
   vitesseBalleCurseur.CaptureMouse();
  }

  void vitesseBalleCurseur_MouseMove(object sender, MouseEventArgs e)
  {
   if (bCurseurVitesseBalleEnAction)
   {
    double X = e.GetPosition(vitesseBalle).X;
    X = Math.Max(0, X);
    X = Math.Min(X, 180);
    double deltaX = X - PosPrec;
    PosPrec = X;
    X = (double)vitesseBalleCurseur.GetValue(Canvas.LeftProperty);
    vitesseBalleCurseur.SetValue(Canvas.LeftProperty, X + deltaX);
   }
  }

  void pistolet_MouseLeftButtonDown(object sender, MouseEventArgs e)
  {
   if (!bAnimEnCours)
   {
    bAnimEnCours = true;
    afficheInfo.Opacity = 0;
    // animation pour vitesse balle
    double X = (double)vitesseBalleCurseur.GetValue(Canvas.LeftProperty);
    X = Math.Max(0, X);
    V = 50 + 400 * X / 180;  // vitesse de la balle en m/s
    // animation pour la balle 
    int n = (int)(1000 / (V / 50));
    daScaleXBalle.Duration = new Duration(new TimeSpan(0, 0, 0, 0, n));
    balle.Opacity = 1;
    animBalle.Begin();
    // bruit du pistolet
    bruitPistolet.Stop(); bruitPistolet.Position = new TimeSpan(0); bruitPistolet.Play();
   }
  }

  void pistolet_MouseLeave(object sender, EventArgs e)
  {
   pistolet.Source = new BitmapImage(new Uri("Pistolet.png", UriKind.Relative));
  }

  void pistolet_MouseEnter(object sender, MouseEventArgs e)
  {
   if (!bAnimEnCours) pistolet.Source = new BitmapImage(new Uri("PistoletVert.png", UriKind.Relative));
  }
 }
}
